
package de.ivu.elect.presentation.benutzerverwaltung.action;

import java.util.Objects;

import javax.annotation.Nonnull;
import javax.inject.Inject;
import javax.inject.Named;

import de.ivu.elect.business.benutzerverwaltung.entity.Benutzer;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.presentation.View;
import de.ivu.elect.presentation.benutzerverwaltung.BenutzerEditView;

@Named(BenutzerDeleteAction.COMPONENT_NAME)
public class BenutzerDeleteAction extends AbstractBenutzerAction {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "benutzerDeleteAction";

  @View
  @Inject
  private transient BenutzerEditView benutzerEditView;

  public BenutzerDeleteAction() {
    super();
  }

  @Override
  protected UseCasePermission getRequiredPermission() {
    return UseCasePermission.BENUTZER_DELETE;
  }

  @Override
  public boolean isDisabledInternal(@Nonnull Benutzer benutzer) {
    return Objects.equals(principal.getLogin(), benutzer) || benutzer.isAdmin() /* Admin nicht löschbar */;
  }

  @Override
  protected String doIt(Benutzer benutzer) {
    benutzerEditView.setEntity(benutzer);

    return null;
  }

  @Override
  protected boolean isFireChangeEvent() {
    return true;
  }

  @Override
  public String getDialogName() {
    return "DeleteConfirm";
  }

  @Override
  public String getLabelKey() {
    return "entity.edit.action.delete";
  }

  @Override
  public String getIcon() {
    return appIcons.getIconDelete();
  }
}
